package tumbler.internal.parsers;

import java.io.*;

import tumbler.internal.domain.*;


public abstract class StepParser {

	public void processStep(ScenarioModel scenario, BufferedReader reader) throws IOException {
		reader.mark(1000);
		String text = reader.readLine();
		if (text != null) {
			String parsed = parseInternal(text.trim());
			if (parsed != null) {
				setParsedValueInScenario(scenario, parsed);
			} else {
				reader.reset();
			}
		}
	}

	protected abstract String parseInternal(String text);

	protected abstract void setParsedValueInScenario(ScenarioModel scenario, String parsed);
}