package tumbler.internal.writers;

import tumbler.internal.*;
import tumbler.internal.domain.*;

public class JavaGenerator {

	public static final String IMPORTS =
			"import org.junit.*;\n" +
			"import static org.junit.Assert.*;\n" +
			"import static tumbler.Tumbler.*;";

	private String javaText;

	public void generateClassFor(StoryModel story) {
		javaText = IMPORTS + "\n\n@RunWith(TumblerRunner.class)\n@Story(\"" + story.name() + "\")\npublic class ";
		String className = story.camelisedName() + "Scenarios";
		javaText += className + " {\n";
		for (ScenarioModel scenario : story.scenarios()) {
			javaText += generateMethodFor(scenario);
		}
		javaText += "}";
	}

	private String generateMethodFor(ScenarioModel scenario) {
		String name = scenario.name();
		name = TumblerUtils.removeSpecialCharacters(name);
		String start = "\n\t@Scenario(";
		if (!name.equals(scenario.name()))
			start += "value = \"" + scenario.name() + "\", ";
		start += "pending = true)\n\tpublic void should" + TumblerUtils.camelise(name) + "() {\n";
		String ending = "\t}\n";
		String content = "\t\tgiven(\"" + scenario.given() + "\");\n\n\t\twhen(\"" + scenario.when()
				+ "\");\n\n\t\tthen(\"" + scenario.then() + "\");\n";
		return start + content + ending;
	}

	public String javaText() {
		return javaText;
	}

}
